/* C implementation for merge sort, originally implemented by Michael Juenger (Cologne). 
   Minor changes by Frauke Liers (Cologne) 08/2011*/
#include <stdio.h>
#include <malloc.h>

void merge_sort();
void merge();

#define infinity 10000000;

int main()

{

  int i,j,n;
  int *A;

  scanf("%d",&n);
  A = (int *) malloc((n+1)*sizeof(int));
  for (i=1; i<=n; i++) {
    scanf("%d",&j);
    A[i] = j;
  }

  merge_sort(A,1,n);

  for (i=1; i<=n; i++) printf("%8d",A[i]);
  printf("\n");

  free(A);
  return 0;

}

void merge_sort(int* A, int p, int r)

{

  int q;

  if (p<r) {
    q = p+((r-p)/2); 			
    merge_sort(A,p,q);
    merge_sort(A,q+1,r);
    merge(A,p,q,r);
  }

}

void merge(int* A, int p, int q, int r)

{
  int i,j,k,ai,aj;
  int *B;

  B = (int *) malloc((r-p+2)*sizeof(int));

  i = p;       ai = A[i];
  j = q + 1;   aj = A[j];
   
  for (k=1; k<=r-p+1; k++) {
    if (ai<aj) {
      B[k] = ai; 
      i++;
      if (i<=q) ai = A[i]; else ai = infinity;
    }
    else {
      B[k] = aj; 
      j++;
      if (j<=r) aj = A[j]; else aj = infinity;
    }
  }
  for (k=p; k<=r; k++) A[k] = B[k-p+1];

  free(B);

}
