/* implementation for Labyrinth exercise, written by Frauke Liers (Cologne) in 08/2011. */
/* for ease of presentation, all functions are in one file. For a larger project, 
   one puts, e.g. the stack implementation in a separate file */

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

//Coordinates of the fields are stored in a struct Coord with x- and y- coordinates. 

typedef struct {
    int x;
    int y;
} Coord;

// here comes an implementation of a stack:

typedef struct {
  Coord *stack;
  int stackpointer; 
  int maxinstack;
} Stack;


void initialize();
int stackempty();
int stackfull();
void push();
Coord pop();
Coord top();

int main(){

  //input (quadratic) labyrinth
    int max; //size of labyrinth
    scanf("%d",&max);
    int i,j;
    int L[max+2][max+2];

  //put 1s around the labyrinth
  for(i = 0; i < max+2; i++){
      L[0][i] = 1;
      L[max+1][i] = 1;
      L[i][0] =  1;
      L[i][max+1] = 1;
  }
  //input of labyrinth. 0 is a white field, 1 a black one (a wall)
  for (i =0; i < max; i++) {
      for (j = 0; j < max; j++) {
	scanf("%d",&L[i+1][j+1]);
      }
  }



  Coord sp; //start
  Coord zp; //end
  scanf("%d", &sp.x);
  scanf("%d", &sp.y);
  scanf("%d", &zp.x);
  scanf("%d", &zp.y);

  sp.x++; sp.y++;
  zp.x++; zp.y++;

  // output labyrinth
  printf("labyrinth\n");
  for ( i =0; i <= max+1; i++) {
      for ( j = 0; j <= max+1; j++) {
	printf("%d ",L[i][j]);
      }
      printf("\n");
  }
  printf("\n");

  printf("start %d, %d\n", sp.x,  sp.y);
  printf("end %d, %d\n", zp.x, zp.y);
  
  /* here comes the algorithm... (to be implemented) */
  
  
  return 0;
}

void initialize(Stack *S, int max)
{
    
    S->maxinstack = max;
    S->stack = (Coord *) malloc(max*sizeof(Coord));
    S->stackpointer = 0;
}


int stackempty(Stack* S)
{
  if(S->stackpointer<=0) return 1;
  return 0;
}

int stackfull(Stack* S)
{
  if(S->stackpointer>=S->maxinstack) return 1;
  return 0;
}

void push(Stack * S,Coord v)
{
  if (stackfull(S)) printf("!!! Stack is full !!!\n");
    else {
	S->stack[S->stackpointer] = v;
	S->stackpointer++;
    }
}

Coord pop(Stack * S)
{
  if (stackempty(S)) {
      printf("!!! Stack is empty !!!\n");
      exit(0);
  }
  S->stackpointer--;
  return S->stack[S->stackpointer];
}

Coord top(Stack * S)
{
    if (stackempty(S)) {
      printf("!!! Stack is empty !!!\n");
      exit(0);
    }
    return S->stack[S->stackpointer-1];
}
